<template>
  <div class="">
   
    <div>
    <label for="">to graph</label>
    <input type="number" v-model="toShow" @change="graphAgent(toShow)">
    <br>
    <input type="number" v-model="short">
    <input type="number" v-model="longStep">
    <button @mousedown="calcinit(short,longStep)">re-calcule</button>
        <canvas id="myChart" :width="w" :height="h"></canvas>
       
    </div>
    <h1>ifo retived:</h1>
    <tr>
     <th>shortEmaN</th>
     <th>longEmaN</th>
    <th>investment</th>
    <th>satoshi</th>
    <th>BUYS</th>
    <th>PBUYS</th>
    <th>SELLS</th>
    <th>PSELLS</th>
    <th>tax</th>
    <th>finar cash</th>
    <th>shortEma</th>
    </tr>
    <tr v-for="ema in emas" :key="ema.PERIOD">
    <td>{{ema.shortEmaN}}</td>
    <td>{{ema.longEmaN}}</td>
    <td>{{ema.investment}}</td>
    <td>{{ema.satoshi}}</td>
    <td>{{ema.BUYS}}</td>
    <td>{{ema.PBUYS}}</td>
    <td>{{ema.SELLS}}</td>
    <td>{{ema.PSELLS}}</td>
    <td>{{ema.tax}}</td>
    <td>{{ema.getState()}}</td>
    <td>{{ema.shortEma}}</td>
    </tr>
    
  </div>
</template>

<script>

import Chart from 'chart.js';
import DataConsumer from '../js/DataConsumer';
const BitsoAPI = require("../js/BitsoApI");
const EmaAgent = require("../js/EmaAgent.js");
export default {
  name: 'pointChart',
  components:{

  },
  props: {
        w : Number,
        h : Number

  },
  data(){
    return{
          chart :"",
          toShow:1,
          short:10,
          longStep:10,
          mData:[],
          emas:[],
          localData:[], 
    }
  },
  methods:{
      addData(data) {  
          this.chart.data.datasets[0].data = data[0];
          this.chart.data.datasets[1].data = data[1];
          this.chart.data.datasets[2].data = data[2];
          this.chart.data.datasets[3].data = data[3];
          this.chart.data.datasets[4].data = data[4];
         // this.graphEMA(30,100);    
          this.chart.update(0); 

      },
      newPoint(msg){
        
      //graph point
        this.localData[2][ema.pointer] = {'x':ema.pointer,'y':this.emas[1].EMA};
        this.addData(this.localData);
      //do the for with all the ema agents

      },
initGraph(){
  var ctx = document.getElementById("myChart");
    this.chart = new Chart(ctx, {
    type: 'line',
    data: {
        datasets: [{
            label: 'ask',
            data: [{x:0,y:0}],
            backgroundColor: '#ff00ff',   
            fill:false},{
            label: 'ema',
            data: [{x:0,y:0}],
            backgroundColor: '#88ffff',   
            fill:false},{
            label: 'bid',
            data: [{x:0,y:0}],
            backgroundColor: '#8888ff',   
            fill:false},{
            label: 'buys',
            data: [{x:0,y:0}],
            backgroundColor: '#ff8888',   
            fill:false},{
            label: 'sells',
            data: [{x:0,y:0}],
            backgroundColor: '#88ff88',   
            fill:false}]
    },
    options: {
        scales: {
            xAxes: [{
                type: 'linear',
                position: 'bottom'
            }]
        }
       
    }
});
          this.localData[0] = [];
          this.localData[1] = [];
          this.localData[2] = [];
          this.localData[3] = [];
          this.localData[4] = [];

},
calcinit(short, longStep){
  console.log("calculando con : ", short,longStep);
  
 for (let index = 0; index < 50; index++) {
      this.emas[index] = new EmaAgent(short,index*longStep,2000,true)
    } 
    //get historic data
    fetch("http://192.168.56.1:3000/getAll").then(resp=>resp.json()).then(response=>{
      //por cada linea alimenta los Emas
      var dif = 0;
      var avrg = 0;
      for (let i = 0; i < response.length; i++) {
        const minute = response[i];
        this.mData[i]=(minute.payload);
        dif+= Number(minute.payload.ask) - Number(minute.payload.bid);
        avrg+= (Number(minute.payload.ask) + Number(minute.payload.bid))/2;
         this.emas.forEach(ema => {
           ema.feed(minute.payload);
         });
      }
       dif /= response.length;
       avrg /= response.length;
       console.log("media de difenrecia",dif, avrg, dif/avrg );
         
      const states = [];
      const cPrice = response[response.length-1].payload.bid;
      for (let i = 0; i < this.emas.length; i++) {
        const ema = this.emas[i];
        states[i]= {index:i,profit:ema.getState(cPrice),invest: ema.investment}
      }
      states.sort((a,b)=>{
         return (a.profit>b.profit)? -1 : 1
      })
      for (let i = 0; i < states.length-1; i++) {
        const ema = states[i];
        //this.localData[2].push( {'x':ema.index,'y':ema.profit});
      }
      // this.addData(this.localData);
      console.log("finalizando calc");
      this.$forceUpdate();
    })
     
    },
    graphAgent(index){
            this.addData(this.emas[index].getGraph(this.mData));
    },
  
  },
 
  // on create
  mounted(){
    // INT EMAS
    this.calcinit(10,10);
    this.bitso = new BitsoAPI(false);
    this.initGraph();
  },
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.canvas{
    height: auto;
    width: 100vw;
}
#mychart{
  width: 100%;
}
td{
  padding: 25px;
}

</style>
